//
//  ViewController.m
//  Test
//
//  Created by 杨建祥 on 17/1/1.
//  Copyright © 2017年 杨建祥. All rights reserved.
//

#import "ViewController.h"
#import "HeaderView.h"
#import "UINavigationBar+Awesome.h"
#import "UIScrollView+APParallaxHeader.h"

@interface ViewController ()
@property (nonatomic, strong) HeaderView *headerView;
@property (nonatomic, weak) IBOutlet UIScrollView *scrollView;
@property (nonatomic, weak) IBOutlet UIView *contentView;
@property (nonatomic, weak) IBOutlet NSLayoutConstraint *contentHeightConstraint;

@end

@implementation ViewController
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.navigationItem.title = @"test";
    
    CGFloat height = CGRectGetHeight(self.headerView.frame);
    self.contentHeightConstraint.constant = height * -1 + 1;
    
    self.navigationController.navigationBar.translucent = YES;
    [self.navigationController.navigationBar setShadowImage:[UIImage new]];
    [self.navigationController.navigationBar lt_setBackgroundColor:[UIColor clearColor]];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.translucent = YES;
    [self.navigationController.navigationBar setShadowImage:[UIImage new]];
    [self.navigationController.navigationBar lt_setBackgroundColor:[UIColor clearColor]];
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    self.navigationController.navigationBar.translucent = NO;
    [self.navigationController.navigationBar setShadowImage:nil];
    [self.navigationController.navigationBar lt_reset];
}

- (void)viewDidLayoutSubviews {
    [super viewDidLayoutSubviews];
    
    if (!self.scrollView.parallaxView) {
        CGFloat height = CGRectGetHeight(self.headerView.frame);
        [self.scrollView addParallaxWithView:self.headerView andHeight:height andShadow:NO];
        [self.scrollView bringSubviewToFront:self.contentView];
    }
}


- (HeaderView *)headerView {
    if (!_headerView) {
        _headerView = [[[NSBundle mainBundle] loadNibNamed:@"HeaderView" owner:nil options:nil] firstObject];
    }
    return _headerView;
}


@end
